unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function enumLang(h:hmodule; t, n:lpctstr; l:word; lst:TListBox):boolean; stdcall;
begin
  if HiWord(Cardinal(n)) <> 0 then
    lst.Items.add(n+' '+inttostr(l))
  else
    lst.Items.add(Format('#%d', [loword(Cardinal(n))])+' '+inttostr(l));
  if t<>'' then;
  result:=true;
end;

function enumNames(h:hmodule; t:lpctstr; n:lptstr; l:pointer):boolean; stdcall;
begin
  EnumResourceLanguages(h, RT_GROUP_ICON, n, @enumlang, integer(l));
  if t<>'' then;
  result:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var h:hmodule;
begin
  if not fileexists(edit1.text) then
    raise exception.create('File '+edit1.text+' not found.');
  h:=LoadLibraryEx(pchar(edit1.text), 0, LOAD_LIBRARY_AS_DATAFILE);
  if h=0 then
    raise exception.create('could not load library '+edit1.text);
  try
    listbox1.clear;
    EnumResourceNames(h, RT_GROUP_ICON, @enumNames, integer(listbox1));
  finally
    FreeLibrary(h);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  edit1.text:='c:\WINDOWS\system32\moricons.dll';
end;

end.
